# Create Attendance Sheet --- www.Tricks12345.com
#-------------Import the Libraries into Python-------------
import openpyxl
from openpyxl.styles import Font,Alignment
import datetime

#Define the workbook path and Load the workbook
Wkbpath = "C:\\Users\\Pavan\\Desktop\\AttendanceSheet\\Create_AttendanceSheet_Openpyxl.xlsx"
wkb = openpyxl.load_workbook(Wkbpath)

#Defined variables for Months and Year, and stored the values through input function 
MinMonth = int(input("Enter the Min Month Number: "))
MaxMonth = int(input("Enter the Max Month Number: "))
Year =  int(input("Enter the Required Year: "))

# Defined two lists -- (i) Day names in a week  (ii) Max number of days in a month
DaysList = ["Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday", "Sunday"]
DaysCount = [31,28,31,30,31,30,31,31,30,31,30,31]

# Defined variable for Input Sheet
InputSH = wkb['Input']

# Applied font properties
fontstyle = Font(name = 'Century',size = 11, bold = True)

try:
    if MinMonth>MaxMonth:
        raise ValueError()
  

    for sheet in  wkb.sheetnames:
        worksh =  wkb[sheet]
        if  worksh.title !=  'Input':
               del  wkb[worksh.title]  

    for MonthNumb in range(MinMonth,MaxMonth+1):         
        SH = wkb.create_sheet(index = len(wkb.sheetnames)+1)
        SH['A1'].value = 'Date'; SH['A1'].font =  fontstyle
        SH['A2'].value = 'Day'; SH['A2'].font =  fontstyle
                
        for r in range(InputSH.max_row):        
            if r >=2:
                SH.cell(row = r+1, column = 1).value = InputSH.cell(row = r+1, column = 1).value
            for DayNumb in range(1,DaysCount[MonthNumb-1]+1):           
                    
                    dt = datetime.date(year=Year, month=MonthNumb, day=DayNumb)                    
                    if r == 0:
                        SH.cell(row = r+1, column = DayNumb+1).value = f"{dt:%B %d, %Y}"            
                        print(f"{dt:%B %d, %Y}")
                        SH.cell(row = r+1, column = DayNumb+1).font =  fontstyle
                        SH.column_dimensions[SH.cell(row = r+1, column = DayNumb+1).column].width = 22
                        SH.cell(row = r+1, column = DayNumb+1).alignment = Alignment(horizontal = 'center', vertical = 'center')                        
                    if r == 1: 
                        SH.cell(row = r+1 , column = DayNumb+1).value = DaysList[(dt.weekday())]
                        SH.cell(row = r+1, column = DayNumb+1).font =  fontstyle                        
                        SH.cell(row = r+1, column = DayNumb+1).alignment = Alignment(horizontal = 'center', vertical = 'center')                                                
                        print(DaysList[(dt.weekday())])
                    if r >=2 and SH.cell(row =  2, column = DayNumb+1).value != 'Sunday':
                        SH.cell(row = r+1, column = DayNumb+1).value = 'P'
                        SH.cell(row = r+1, column = DayNumb+1).alignment = Alignment(horizontal = 'center', vertical = 'center')                        
                        
        SH.title = f"{dt:%B}" + "  " + str(Year)         
except ValueError:
    print('Min value should be Less than Max value')

finally:
    wkb.save(Wkbpath)
    print('Execution completed')
 
